package PreviewTargetChanger::CMS;
use strict;

sub _preview_entry {
    my ($cb, $app, $tmpl) = @_;

    my $old = <<HERE;
  </head>
HERE
    $old = quotemeta($old);

    my $new = <<HERE;
<style type="text/css">
#brand a, .preview-screen #brand {
	display: none;
}
.preview-screen #entry-preview-control-strip, .preview-screen #template-preview-control-strip {
	display: none;
}
.no_display {
    display:none;
}
</style>
  </head>
HERE

    $$tmpl =~ s/$old/$new/;

    my $old = <<HERE;
    <table id="entry-preview-layout" class="preview-layout">
      <tr>
HERE
    $old = quotemeta($old);

    my $new = <<HERE;
    <table id="entry-preview-layout" class="preview-layout">
      <tr class="no_display">
HERE

    $$tmpl =~ s/$old/$new/;
}

sub _edit_entry {
    my ($cb, $app, $tmpl) = @_;

    my $plugin = MT->component("PreviewTargetChanger");
    my $target = $plugin->get_config_value('entry_target', 'blog:'.$app->blog->id);

    my $old = <<HERE;
<mt:setvarblock name="jq_js_include" append="1">
    jQuery('button.preview').click(function(event) {
        jQuery('form#entry_form input[name=__mode]').val('preview_entry');
    });
HERE
    $old = quotemeta($old);

    my $new = <<HERE;
<mt:setvarblock name="jq_js_include" append="1">
    jQuery('button.preview').click(function(event) {
        jQuery('form#entry_form input[name=__mode]').val('preview_entry');
        jQuery('form#entry_form > input[name=status]').val(100);
        jQuery('form#entry_form').removeAttr("mt:once");

        var w = window.open("about:blank", "mt-preview", 'width=1000, height=600');
        w.focus();

        jQuery('form#entry_form').prop("target", "mt-preview");
    });
HERE

    $$tmpl =~ s/$old/$new/;

    $old = <<HERE;
    jQuery('select#status').change( setSaveButtonText );
HERE
    $old = quotemeta($old);

    $new = <<HERE;
    jQuery('select#status').change( setSaveButtonText );

    jQuery('button.publish').click(function(event) {
        jQuery('form#entry_form input[name=__mode]').val('save_entry');
        jQuery('form#entry_form').removeAttr("onsubmit");
        jQuery('form#entry_form').removeAttr("target");
//        jQuery('form#entry_form').attr("mt:once","1");
    });
HERE

    $$tmpl =~ s/$old/$new/;
}

sub _preview_template {
    my ($cb, $app, $tmpl) = @_;

    my $old = <<HERE;
</head>
HERE
    $old = quotemeta($old);

    my $new = <<HERE;
<style type="text/css">
#brand a, .preview-screen #brand {
	display: none;
}
.preview-screen #entry-preview-control-strip, .preview-screen #template-preview-control-strip {
	display: none;
}
.no_display {
    display:none;
}
</style>
</head>
HERE
    $$tmpl =~ s/$old/$new/;

    my $old = <<HERE;
    <table id="template-preview-layout" class="preview-layout">
      <tr>
HERE
    $old = quotemeta($old);

    my $new = <<HERE;
    <table id="template-preview-layout" class="preview-layout">
      <tr class="no_display">
HERE

    $$tmpl =~ s/$old/$new/;
}

sub _edit_template {
    my ($cb, $app, $tmpl) = @_;

    my $plugin = MT->component("PreviewTargetChanger");
    my $target = $plugin->get_config_value('template_target', 'blog:'.$app->blog->id);

    my $old = <<HERE;
<mt:include name="include/header.tmpl">
HERE
    $old = quotemeta($old);

    my $new = <<HERE;
<mt:include name="include/header.tmpl">
<script type="text/javascript">
function preview_with_new_window(f) {
    jQuery('form#template-listing-form').attr("onsubmit","return false");
    jQuery('form#template-listing-form').removeAttr("mt:once");
    f.target = "hoge";
HERE

if($target){
    $new .= <<HERE;
    var w = window.open("about:blank", f.target, 'width=1000, height=600');
    w.focus();
HERE
}
    $new .= <<HERE;
    f.submit();
}
</script>
HERE
    $$tmpl =~ s/$old/$new/;

    $old = <<HERE;
  <button
     name="preview_template"
HERE
    $old = quotemeta($old);

    $new = <<HERE;
  <button
     onclick="preview_with_new_window(this.form)"
     name="preview_template"
HERE

    $$tmpl =~ s/$old/$new/;

    $old = <<HERE;
    jQuery('button.save, button.publish').click(function() {
HERE
    $old = quotemeta($old);

    $new = <<HERE;
    jQuery('button.save, button.publish').click(function() {
        jQuery('form#template-listing-form').removeAttr("onsubmit");
        jQuery('form#template-listing-form').attr("target","_self");
HERE

    $$tmpl =~ s/$old/$new/;

    $old = <<HERE;
    jQuery('button.preview').click(function() {
HERE
    $old = quotemeta($old);

    $new = <<HERE;
    jQuery('button.preview').click(function() {
        jQuery('form#template-listing-form').attr("onsubmit","return false");
        jQuery('form#template-listing-form').removeAttr("mt:once");
HERE

    $$tmpl =~ s/$old/$new/;
}

1;
